from simpleEX import *
import random,math
def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
#-----遺伝子操作用関数------------
def randomNode(H,TR):#■ランダムな部分木の選択
    if TR[0]=="numb" or TR[0]=="name":return []
    R=random.random()
    if R<0.1: return [H,TR]
    if TR[0][0]=="func": return randomNode(H+[1],TR[1])
    if TR[0][0]=="delm":
        if TR[0][1]=="-$" or TR[0][1]=="+$":
            return randomNode(H+[1],TR[1])
        else:
            if R<0.55: return randomNode(H+[1],TR[1])
            return randomNode(H+[2],TR[2])
def randomProc(TR):#■ランダムな部分木の選択
    DNODE=[]       #  (リーフのとき再選択)
    while DNODE==[]:DNODE=randomNode([],TR)
    return DNODE
def copyDelH(H):#■リスト先頭の削除と複写
    N=len(H); HH=[0 for i in range(N-1)]
    for i in range(N-1): HH[i]=H[i+1]
    return HH
def crossTree(H,TR,DN):#■交叉処理(部分木位置のサーチと置換え)
    if TR[0]=="numb" or TR[0]=="name":return TR
    if H==[]:return DN    # H : 部分木位置リスト
    HH=copyDelH(H)        # HH: 子への伝達部分木位置リスト
    if H[0]==1:
        if TR[0][0]=="func": return [TR[0],crossTree(HH,TR[1],DN)]
        if TR[0][0]=="delm":
            if TR[0][1]=="-$" or TR[0][1]=="+$":
                return [TR[0],crossTree(HH,TR[1],DN)]
            else:
                return [TR[0],crossTree(HH,TR[1],DN),TR[2]]
    elif H[0]==2:# 2項演算子用オペランド
        if (TR[0][0]=="func" or
            (TR[0][0]=="delm" and
             (TR[0][1]=="-$" or TR[0][1]=="+$"))):
            print("内部エラー");return TR
        elif TR[0][0]=="delm":
            return [TR[0],TR[1],crossTree(HH,TR[2],DN)]
        else:print("内部エラー"); return TR
mutationFlag=False
def mutationNode(TR,VL):#■突然変異
    global mutationFlag
    fnameTab=["sin","cos","tan","exp","log","int","abs"]
    delTab=["+","-","*","/","**"]#四則演算のみ対応する
    if mutationFlag: return TR
    R=random.random();V=random.random()
    if R<0.2:
        mutationFlag=True #突然変異の実行
        if TR[0]=="numb":return [TR[0],str(V*5)]#値変更
        if TR[0]=="name":
            ID=int(V*len(VL))#異なる変数名に変更
            while TR[1]==VL[ID][0]:
                V=random.random();ID=int(V*len(VL))
            return [TR[0],VL[ID][0]]
        if TR[0][0]=="func":
            ID=int(V*len(fnameTab))#異なる関数名に変更
            while TR[0][1]==fnameTab[ID]:
                V=random.random();ID=int(V*len(fnameTab))
            return [[TR[0][0],fnameTab[ID]],TR[1]]
        #以下 TR[0][0]=="delm" (#演算子変更)
        if TR[0][1]=="-$":#  単項演算子(-)変更
            return [[TR[0][0],"+$"],TR[1]]
        if TR[0][1]=="+$":#  単項演算子(+)変更
            return [[TR[0][0],"-$"],TR[1]]
        else:             #  2項演算子変更
            ID=int(V*len(delTab))
            while TR[0][1]==delTab[ID]:#異なる演算子に変更
                V=random.random();ID=int(V*len(delTab))
            return [[TR[0][0],delTab[ID]],TR[1],TR[2]]
    if TR[0]=="numb" or TR[0]=="name":return TR
    if TR[0][0]=="func":
        return [TR[0],mutationNode(TR[1],VL)]
    if TR[0][0]=="delm":
        if TR[0][1]=="-$" or TR[0][1]=="+$":
            return [TR[0],mutationNode(TR[1],VL)]
        else:
            return [TR[0],mutationNode(TR[1],VL),
                    mutationNode(TR[2],VL)]
def mutationProc(TR,VL):#■突然変異
    global mutationFlag
    mutationFlag=False #突然変異が起きるまで実行
    while not(mutationFlag):R=mutationNode(TR,VL)
    return R
#-----適応度選択用関数--------------
def setFitness(V0, NAREA, Area, VL):#■適応度計算
    Fitness=array(NAREA)            #   V0:出力例示(真値)
    for i in range(NAREA):# 各式の計算
        try:V1=execTree(Area[i],VL)# 各式の実行
        except: V1=1E30 # エラーのときペナルティ値設定
        Fitness[i]=1/(abs(V1-V0)+1) # 真値＝式の値のとき1
    return Fitness                  # 真値≠式の値のとき1未満
def totalFitness(FitNess):#■適応度合計
    NUM=len(FitNess); T=0
    for i in range(NUM):T+=FitNess[i]
    return T
def cumDisp(Fitness):#■累積分布生成
    NUM=len(Fitness);D=array(NUM);cD=array(NUM)
    T=totalFitness(Fitness)
    for i in range(NUM): D[i]=Fitness[i]/T
    cD[0]=D[0]
    for i in range(1,NUM): cD[i]=cD[i-1]+D[i]
    return cD
def selectUnit(CDisp):#■要素選択
    R=random.random();NUM=len(CDisp)
    for i in range(NUM):
        if R<CDisp[i]:return i
    return NUM-1
def checkFitness(Fitness):#■適応度のチェック
    for i in range(len(Fitness)):
        if Fitness[i]>0.99999:return False
    return True
#-----変数名設定用-----------
def setVL(VL):#■変数名リストのランダム設定
    N=len(VL); R=array(N,2)
    for i in range(N):
        R[i][0]=VL[i][0]
        R[i][1]=random.random()*5+0.1
    return R
#-----適応度リスト表示用------
def printFitness(Fit):
    print("\n■適応度リスト\n")
    S=""
    for i in range(len(Fit)):
        if i%5==0:S+="\n"
        S+="%10.5f " % Fit[i]
    print(S)

